## Goal
The goal of this homework is to implement an interpreter and static analyzers for the miniC language.   
The syntax of the language is defined in "hw3.pdf".

## Specification
- Implement functions and modules left blank in "interpreter.ml" and "domains.ml".
- Do not modify the types and names of items in the "c.ml".  
- You can use the data structures and helper functions which are provided as built-in.
- During execution, raise the exception *UndefSemantics* whenever an undesriable situation occurs.

## Compilation and Execution
Compile and execute the interpreter as follows:
```
  make clean; make     (* for compilation *)
  ./run -mode 1 test/test1.c  (* run the interpreter *)
  ./run -mode 2 -print_mem test/test1.c  (* run the collecting semantics-based interpreter and print the concrete state *)
  ./run -mode 3 -print_mem test/test1.c (* run the abstract interpreter based on the parity domain  *)
  ./run -mode 4 -print_mem test/test1.c (* run the abstract interpreter based on the interval domain *) 
```

## Correctness 
You may use the test programs under the 'test' folder.

